/* mandel */
/* A little example that renders a mandelbrot into ANSI-Draw's buffer */


address ANSIDRAW
options results

'LOCK INPUT'

width = 80
'QUERY BUFFER_ROWS'
height = result-1

crmin = -2
crmax = 1.1
cimin = -1.6
cimax = 1.6

crstep = (crmax-crmin) / width
cistep = (cimax-cimin) / height

ci = cimin
cr = crmin

DO i = 1 to height
   DO j = 1 to width

      a = 0
      b = 0
      k = 0
      zabs = 0;

      DO WHILE ((zabs < 4) & (k < 16))
         zr = a*a - b*b + cr
         zi = 2*a*b + ci

         a = zr
         b = zi

         k = k + 1
         zabs = a*a + b*b
      END

      if(k>15) THEN k=15

      'GO COLUMN ' j
      'GO ROW ' i

      'SET COLOR_FOREGROUND ' k
      'DRAW CHARACTER 177'

   cr = cr + crstep

   END

   cr = crmin
   ci = ci + cistep
END

'GO COLUMN 1 ROW 1'
'UNLOCK INPUT'
